<?php
add_action("init", "dippsy_ipn");

function dippsy_ipn()
{
	/*
	 if(!in_array($_SERVER['REMOTE_ADDR'],
	 array('216.113.188.202','216.113.188.203','216.113.188.204','66.211.170.66')))
	 {
		header("HTTP/1.0 404 Not Found");
		wp_die("You ain't no PayPal!");
		}
		*/

	//by bueltge
	if ( isset($_POST['txn_id']))
	{
		status_header( 200 );

		//Read the post from PayPal and add 'cmd'
		$req = 'cmd=_notify-validate';

		foreach ($_POST as $key => $value)
		{
			$value = urlencode(stripslashes($value));
			$req .= "&$key=$value";
		}

		//by
		if ( !isset($header) )
			$header  = '';
		// Post back to PayPal to validate
		$header .= "POST /cgi-bin/webscr HTTP/1.0\r\n";
		$header .= "Content-Type: application/x-www-form-urlencoded\r\n";
		$header .= "Content-Length: " . strlen($req) . "\r\n\r\n";

		if(get_option('dippsy_use_sandbox'))
		{
			$fp = fsockopen ('www.sandbox.paypal.com', 80, $errno, $errstr, 30);
		}
		else
		{
			$fp = fsockopen ('www.paypal.com', 80, $errno, $errstr, 30);
		}

		// Process validation from PayPal
		if (!$fp)
		{
			dippsy_log("Paypal Validation failed: HTTP Error.");
		}
		else
		{
			// NO HTTP ERROR
			fputs ($fp, $header . $req);

			while (!feof($fp))
			{
				$res = fgets ($fp, 1024);
				
				//by
				if ( strcmp($res, "VERIFIED") == 0 )
				{
					//paypal transaction fields
					$txn_id = $_POST['txn_id'];
					$product_name = $_POST['item_name'];
					$file_id = $_POST['item_number'];
					$payment_amount = $_POST['mc_gross'];
					$payment_currency = $_POST['mc_currency'];
					$receiver_email = $_POST['receiver_email'];
					$payer_email = $_POST['payer_email'];
					$payer_name = $_POST['first_name'];
					$payer_surname = $_POST['last_name'];
					$payment_status = $_POST['payment_status'];
					
					//get transaction data from database
					$transaction = dippsy_get_order_by_txn($txn_id);
					
					if(!empty($transaction))
					{
						$file = dippsy_get_file_from_order($transaction->ID);
						$price_show = round(get_post_meta($file->ID,"dippsy_file_price",true),2);
						$tax = round((get_option('dippsy_tax')/100)*$price_show,2);
						$price = round($price_show-$tax,2);
						
						if($file_id != $file->ID)
						{
							$status = "Invalid product: ".$file_id;
						}
						elseif(strtolower($product_name) != strtolower(get_post_meta($file->ID,"dippsy_file_name",true)))
						{
							$status = "Wrong item name: ".$product_name;
						}
						elseif(strtolower($receiver_email) != strtolower(get_option('dippsy_paypal_email')))
						{
							$status = "Seller e-Mail is wrong: ".$receiver_email;
						}
						//compatibility with older releases
						elseif(floatval($payment_amount) != floatval(get_post_meta($file->ID,"dippsy_file_price",true)) || floatval($payment_amount) != floatval($price))
						{
							$status = "Invalid price: ".$payment_amount;
						}
						elseif($payment_currency != get_option('dippsy_currency_code'))
						{
							$status = "Wrong currency: ".$payment_currency;
						}
						elseif($payer_email != get_post_meta($transaction->ID,"dippsy_order_payer_mail",true))
						{
							$status = "Wrong payer e-Mail: ".$payer_email;
						}
						elseif($payer_name != get_post_meta($transaction->ID,"dippsy_order_payer_name",true))
						{
							$status = "Wrong payer name: ".$payer_name;
						}
						elseif($payer_surname != get_post_meta($transaction->ID,"dippsy_order_payer_surname",true))
						{
							$status = "Wrong payer surname: ".$payer_surname;
						}
						elseif($payment_status == "Completed")
						{
							if(get_post_meta($transaction->ID,"dippsy_order_status",true) != "Completed")
							{
								$hash = sha1(uniqid(mt_rand(), true).$file_id.$payer_email);
								$date=strftime('%Y-%m-%d %H:%M:%S',mktime());
								//$paymentDateTmp=strtotime($_POST['payment_date']);
									
								update_post_meta($transaction->ID,"dippsy_order_hash",$hash);
								update_post_meta($transaction->ID,"dippsy_order_status","Completed");
								update_post_meta($transaction->ID,"dippsy_order_cleared_date",$date);
								update_post_meta($transaction->ID,"dippsy_order_download_count",0,true);
								
								//send completed mail
								dippsy_completed_mail($transaction->ID);
								
								$status = "Order ".$txn." successfully COMPLETED!";
							}
						}
						else
						{
							//update borked status
							update_post_meta($transaction->ID,"dippsy_order_status",$payment_status);

							//send status changed mail
							dippsy_changed_mail($transaction->ID);
							
							/*don't really need this
							//remove hash, if status failed/denied/expired/partially refunded/refunded/reversed/voided
							$status = array("Cancelled","Failed","Denied","Expired","Partially refunded","Refunded","Reversed","Voided");

							if(in_array($payment_status,$status))
							{
								update_post_meta($transaction->ID,"dippsy_order_hash","");
								//delete_post_meta($transaction->ID,"dippsy_order_hash");
							}*/
						}
					}
					else
					{
						$file = dippsy_get_file($file_id);
						$price_show = round(get_post_meta($file->ID,"dippsy_file_price",true),2);
						$tax = round((get_option('dippsy_tax')/100)*$price_show,2);
						$price = round($price_show-$tax,2);

						if(empty($file))
						{
							$status = "Invalid product file";
						}
						elseif(strtolower($product_name) != strtolower(get_post_meta($file->ID,"dippsy_file_name",true)))
						{
							$status = "Wrong item name: ".$product_name;
						}
						elseif(strtolower($receiver_email) != strtolower(get_option('dippsy_paypal_email')))
						{
							$status = "Seller e-Mail is wrong: ".$receiver_email;
						}
						//compatibility with older releases
						elseif(floatval($payment_amount) != floatval(get_post_meta($file->ID,"dippsy_file_price",true)) && floatval($payment_amount) != floatval($price))
						//elseif(floatval($payment_amount) != floatval(get_post_meta($file->ID,"dippsy_file_price",true)))
						{
							$status = "Invalid price: ".$payment_amount;
						}
						elseif($payment_currency != get_option('dippsy_currency_code'))
						{
							$status = "Wrong currency: ".$payment_currency;
						}
						elseif($payment_status == "Completed")
						{
							$hash = sha1(uniqid(mt_rand(), true).$file_id.$payer_email);
							$date=strftime('%Y-%m-%d %H:%M:%S',mktime());

							$post = array(
									    'post_content' => "Type: PayPal",
									    'post_title' => "Dippsy order",
										'post_type' => 'dippsy_order',
										'post_status' => 'private',
										'comment_status' => 'closed',
								 		'ping_status' => 'closed', 
							);

							$post_id = wp_insert_post($post);
								
							add_post_meta($post_id,"dippsy_order_txn_id",$txn_id,true);
							add_post_meta($post_id,"dippsy_order_file",$file_id,true);
							add_post_meta($post_id,"dippsy_order_payer_mail",$payer_email,true);
							add_post_meta($post_id,"dippsy_order_payer_name",$payer_name,true);
							add_post_meta($post_id,"dippsy_order_payer_surname",$payer_surname,true);
							add_post_meta($post_id,"dippsy_order_order_date",$date,true);
							add_post_meta($post_id,"dippsy_order_cleared_date",$date,true);
							add_post_meta($post_id,"dippsy_order_status",$payment_status,true);
							add_post_meta($post_id,"dippsy_order_hash",$hash,true);
							add_post_meta($post_id,"dippsy_order_download_count",0,true);

							//send completed mail
							dippsy_completed_mail($post_id);
								
							//log
							$status = "Order ".$txn_id." successfully COMPLETED!";
						}
						else
						{
							$date=strftime('%Y-%m-%d %H:%M:%S',mktime());

							$post = array(
									    'post_content' => "Type: PayPal",
									    'post_title' => "Dippsy order",
										'post_type' => 'dippsy_order',
										'post_status' => 'private',
										'comment_status' => 'closed',
								 		'ping_status' => 'closed', 
							);

							$post_id = wp_insert_post($post);

							add_post_meta($post_id,"dippsy_order_txn_id",$txn_id,true);
							add_post_meta($post_id,"dippsy_order_file",$file_id,true);
							add_post_meta($post_id,"dippsy_order_payer_mail",$payer_email,true);
							add_post_meta($post_id,"dippsy_order_payer_name",$payer_name,true);
							add_post_meta($post_id,"dippsy_order_payer_surname",$payer_surname,true);
							add_post_meta($post_id,"dippsy_order_order_date",$date,true);
							add_post_meta($post_id,"dippsy_order_status",$payment_status,true);
							
							//send pending mail
							dippsy_order_mail($post_id);

							//log
							$status = "Status: ".$payment_status;
						}
							
						dippsy_log($status);
					}

				}
				else if (strcmp ($res, "INVALID") == 0)
				{
					$message = "IPN request FAILED:\n";

					foreach ($_POST as $key => $value){
						$message .= $key . " = " .$value ."\n\n";
					}

					dippsy_log($message);
				}
			}
		}

		fclose ($fp);
	}

}
?>