(function() 
{
	tinymce.PluginManager.requireLangPack('Dippsy');

	tinymce.create('tinymce.plugins.Dippsy', 
	{
		init : function(ed, url) 
		{
			ed.addCommand('Dippsy', function() {
				ed.windowManager.open({
					file : url + '/dippsy_dialog.php',
					width : 280,
					height : 220,
					inline : 1
				}, {
					plugin_url : url, // Plugin absolute URL
				});
			});

			// Register example button
			ed.addButton('Dippsy', {
				title : 'Insert Dippsy products shortcode',
				cmd : 'Dippsy',
				image : url + '/img/dippsy.gif'
			});
		},

		getInfo : function() {
			return {
				longname : 'Dippsy products shortcode plugin',
				author : 'paxman',
				authorurl : 'http://paxman.blog.siol.net',
				infourl : 'http://dippsy.cz.cc',
				version : "1.0"
			};
		}
	});

	tinymce.PluginManager.add('Dippsy', tinymce.plugins.Dippsy);
})();