<?php
add_action("load-post-new.php","dippsy_product_edit");
add_action("load-edit.php","dippsy_order_manage");
add_action("dbx_post_advanced","dippsy_product_manage");
add_action('admin_head', 'dippsy_admin_js_variables' );

/*
add_action('wp_footer','dippsy_head_js');

function dippsy_head_js()
{
	?>
<script type="text/javascript">

</script>

	<?php
}*/

function dippsy_store_css()
{
	echo  "<link type='text/css' rel='stylesheet' href='" .CSS_URL."store.css' />";
}

function dippsy_admin_js_variables()
{
?>
<script type="text/javascript">
var dippsy_delete_file_nonce = '<?php echo wp_create_nonce('dippsy_delete_file_nonce'); ?>';
var dippsy_delete_product_nonce = '<?php echo wp_create_nonce('dippsy_delete_product_nonce'); ?>'; 
var dippsy_add_file_nonce = '<?php echo wp_create_nonce('dippsy_add_file_nonce'); ?>'; 
var dippsy_check_products_nonce = '<?php echo wp_create_nonce('dippsy_check_products_nonce'); ?>'; 
var dippsy_check_images_nonce = '<?php echo wp_create_nonce('dippsy_check_images_nonce'); ?>'; 
var dippsy_send_ordered_nonce = '<?php echo wp_create_nonce('dippsy_send_ordered_nonce'); ?>'; 
var dippsy_send_changed_nonce = '<?php echo wp_create_nonce('dippsy_send_changed_nonce'); ?>'; 
var dippsy_send_completed_nonce = '<?php echo wp_create_nonce('dippsy_send_completed_nonce'); ?>'; 
var dippsy_resend_completed_nonce = '<?php echo wp_create_nonce('dippsy_resend_completed_nonce'); ?>'; 
var dippsy_change_order_status_nonce = '<?php echo wp_create_nonce('dippsy_change_order_status_nonce'); ?>'; 
var dippsy_add_button_nonce = '<?php echo wp_create_nonce('dippsy_add_button_nonce'); ?>'; 

var no_files_yet = '<?php _e("No files yet.", 'dippsy'); ?>';
var set_price = '<?php _e("You must set download price!", 'dippsy'); ?>';
var set_file = '<?php _e("You must select file!", 'dippsy'); ?>';
var set_description = '<?php _e("You must set download description!", 'dippsy'); ?>';
var set_button = '<?php _e("You must select button image!", 'dippsy'); ?>';

var delete_file = '<?php _e("Delete", 'dippsy'); ?>';
var tooltip_error = '<?php _e("ERROR: No information found", 'dippsy'); ?>';

var dissapear = 30000; 

function set_spinner(status) 
{
	status.attr("src", "../wp-admin/images/wpspin_light.gif");
	//status.css('background', 'url(../wp-admin/images/wpspin_light.gif) no-repeat');
	status.fadeTo(0,1);
}

function set_yes(status) 
{
	//status.css('background', 'url(../wp-admin/images/yes.png) no-repeat');
	status.attr("src", "../wp-admin/images/yes.png");
}

function set_no(status) 
{
	status.attr("src", "../wp-admin/images/no.png");
	//status.css('background', 'url(../wp-admin/images/no.png) no-repeat');
}

function set_tooltip(status,response)
{
	status.attr('title',response);
	status.simpletooltip();
	status.fadeTo(dissapear,0,function(){status.unbind('mouseenter mouseleave');});
}

</script>
<?php
}

function dippsy_product_edit()
{
	global $typenow;

	if($typenow == 'dippsy_product')
	{
		wp_enqueue_script('ajaxupload',JS_URL."ajaxupload.js",array('jquery'));
 	    wp_enqueue_script('dippsy_tooltips_js', JS_URL."tooltip.js",array('jquery'));
  	    wp_enqueue_script('dippsy_products_js', JS_URL."products.js",array('jquery'));
 	    
		wp_enqueue_style('dippsy_products_css', CSS_URL."products.css");
		wp_enqueue_style('dippsy_tooltip_css', CSS_URL."tooltip.css");		
		
	}
}

function dippsy_order_manage ()
{
	global $typenow;

	if($typenow == 'dippsy_order')
	{
		add_filter('editable_slug','dippsy_quick_edit_fields');
		
		wp_deregister_script('inline-edit-post');
		wp_register_script( 'inline-edit-post', JS_URL."inline-edit-post.js",array('jquery'));
	
		wp_enqueue_script('dippsy_tooltips_js', JS_URL."tooltip.js",array('jquery'));
		wp_enqueue_script('dippsy_orders_js', JS_URL."orders.js",array('jquery'));
			
		wp_enqueue_style('dippsy_orders_css', CSS_URL."orders.css");
		wp_enqueue_style('dippsy_tooltip_css', CSS_URL."tooltip.css");				
		
	}
}

function dippsy_product_manage ()
{
	global $post_type_object;

	if($post_type_object->name == 'dippsy_product')
	{
		wp_enqueue_script('ajaxupload',JS_URL."ajaxupload.js",array('jquery'));
 	    wp_enqueue_script('dippsy_tooltips_js', JS_URL."tooltip.js",array('jquery'));
 	    wp_enqueue_script('dippsy_products_js', JS_URL."products.js",array('jquery'));
  	    
		wp_enqueue_style('dippsy_products_css', CSS_URL."products.css");
		wp_enqueue_style('dippsy_tooltip_css', CSS_URL."tooltip.css");		
	}
}

function dippsy_dashboard_css() 
{
	echo "<link type='text/css' rel='stylesheet' href='".site_url()."/wp-admin/load-styles.php?c=0&dir=ltr&load=dashboard' />";
} 

function dippsy_settings_css() 
{
		wp_enqueue_style('dippsy-settings-css',CSS_URL."settings.css");
		wp_enqueue_style('dippsy_tooltip_css', CSS_URL."tooltip.css");				
}

function dippsy_dashboard_js() 
{
		wp_enqueue_script('dippsy-dashboard-js',JS_URL."dashboard.js",array('jquery'));
} 

function dippsy_settings_js() 
{
	add_filter( 'disable_captions', create_function('$a', 'return true;') );
	
	wp_enqueue_script('dippsy-cookies-js',JS_URL."cookies.js",array('jquery'));
	wp_enqueue_script('ajaxupload',JS_URL."ajaxupload.js",array('jquery'));
	wp_enqueue_script('dippsy_tooltips_js', JS_URL."tooltip.js",array('jquery'));
	wp_enqueue_script('dippsy-settings-js',JS_URL."settings.js",array('jquery','jquery-ui-tabs'));
		
		//get_image_tag();
		 /*TinyMCE*/
	wp_enqueue_script('jquery');
    wp_enqueue_script( 'common' );
    wp_enqueue_script( 'jquery-color' );
    wp_enqueue_scripts('editor');
    if (function_exists('add_thickbox')) add_thickbox();
    wp_print_scripts('media-upload');
    if (function_exists('wp_tiny_mce')) wp_tiny_mce(false);
    wp_admin_css();
    wp_enqueue_script('utils');
    do_action("admin_print_styles-post-php");
    do_action('admin_print_styles');
    remove_all_filters('mce_external_plugins');
		
} 
?>