<?php
add_action('admin_init', 'dippsy_tinymce_plugin');

function dippsy_tinymce_plugin()
{
	if (!is_admin() || ! current_user_can('edit_posts') || ! current_user_can('edit_pages') )
		return;

	if ( get_user_option('rich_editing') == 'true')
	{
		add_filter("mce_external_plugins", "dippsy_tinymce_add_plugin");
		add_filter('mce_buttons', 'dippsy_tinymce_register_button');
	}
}

function dippsy_tinymce_register_button($buttons)
{
	array_push($buttons, "separator", "Dippsy");
	return $buttons;
}

function dippsy_tinymce_add_plugin($plugin_array)
{
	$plugin_array['Dippsy'] = plugins_url('js/tinymce/dippsy_plugin.js',__FILE__);
	return $plugin_array;
}

?>