jQuery(document).ready(function()
{
	jQuery('.dippsy_more').live('click', function(e)
	{
		e.preventDefault();

		var button = jQuery(this);
		var id = button.attr('alt');
		var resend_mail = jQuery('.resend_mail_'+id);
		
		resend_mail.toggle();

		return false;
	});
	
	jQuery('.dippsy_resend_completed').live('click', function(e)
			{
				e.preventDefault();
				
				var button = jQuery(this);
				var status = jQuery('.dippsy_resend_status',button.closest('tr'));
				//alert(status);
				
				set_spinner(status);
				
				jQuery.post(ajaxurl, 
						{
							"action":"dippsy_resend_completed",
							"dippsy_order_id": button.attr('alt'),
							"dippsy_resend_completed_nonce" : dippsy_resend_completed_nonce
						}, 
						function(response) 
						{
							var res = jQuery.parseJSON(response);

							if(res.status == "SUCCESS")
							{
								set_yes(status);
							}
							else
							{
								set_no(status);
							}
							
							set_tooltip(status,res.message);
						}
				);
				
			return false;
		});
	
	jQuery('.dippsy_change_order_status').live('click', function(e)
			{
				e.preventDefault();
				
				var button = jQuery(this);
				var status = jQuery('.dippsy_change_order_status_status',button.closest('tr'));
				//alert(status);
				
				set_spinner(status);
				
				jQuery.post(ajaxurl, 
						{
							"action":"dippsy_change_order_status",
							"dippsy_order_id": button.attr('alt'),
							"dippsy_change_to": jQuery('#dippsy_status_change').val(),
							"dippsy_change_order_status_nonce" : dippsy_change_order_status_nonce
						}, 
						function(response) 
						{
							var res = jQuery.parseJSON(response);

							if(res.status == "SUCCESS")
							{
								set_yes(status);
							}
							else
							{
								set_no(status);
							}
							
							set_tooltip(status,res.message);
						}
				);
				
			return false;
		});
	
});