jQuery(document).ready(function()
{
	function rnd(){ return String((new Date()).getTime()).replace(/\D/gi,'') }
	
	jQuery("#tabs").tabs({
		cookie:{expires: 1}}
	);

	jQuery('#dippsy_check_images').live('click', function(e)
			{
				e.preventDefault();
				
				var button = jQuery(this);
				var status = jQuery('.dippsy_images_status',button.closest('tr'));
				//alert(status);
				
				set_spinner(status);
				
				jQuery.post(ajaxurl, 
						{
							"action":"dippsy_check_images",
							"dippsy_check_images_nonce" : dippsy_check_images_nonce
						}, 
						function(response) 
						{
							var res = jQuery.parseJSON(response);

							if(res.status == "SUCCESS")
							{
								set_yes(status);
							}
							else
							{
								set_no(status);
							}
							
							set_tooltip(status,res.message);
						}
				);
				
			return false;
		});
	
	jQuery('#dippsy_check_products').live('click', function(e)
			{
				e.preventDefault();
				
				var button = jQuery(this);
				var status = jQuery('.dippsy_products_status',button.closest('tr'));
				//alert(status);
				
				set_spinner(status);
				
				jQuery.post(ajaxurl, 
						{
							"action":"dippsy_check_products",
							"dippsy_check_products_nonce" : dippsy_check_products_nonce
						}, 
						function(response) 
						{
							var res = jQuery.parseJSON(response);

							if(res.status == "SUCCESS")
							{
								set_yes(status);
							}
							else
							{
								set_no(status);
							}
							
							set_tooltip(status,res.message);
						}
				);
				
			return false;
		});
	
	jQuery('#dippsy_send_ordered').live('click', function(e)
			{
				e.preventDefault();
				
				var button = jQuery(this);
				var status = jQuery('.dippsy_ordered_status',button.closest('tr'));
				//alert(status);
				
				set_spinner(status);
				
				jQuery.post(ajaxurl, 
						{
							"action":"dippsy_send_ordered",
							"dippsy_send_ordered_nonce" : dippsy_send_ordered_nonce
						}, 
						function(response) 
						{
							var res = jQuery.parseJSON(response);

							if(res.status == "SUCCESS")
							{
								set_yes(status);
							}
							else
							{
								set_no(status);
							}
							
							set_tooltip(status,res.message);
						}
				);
				
			return false;
		});
	
	jQuery('#dippsy_send_changed').live('click', function(e)
			{
				e.preventDefault();
				
				var button = jQuery(this);
				var status = jQuery('.dippsy_changed_status',button.closest('tr'));
				//alert(status);
				
				set_spinner(status);
				
				jQuery.post(ajaxurl, 
						{
							"action":"dippsy_send_changed",
							"dippsy_send_changed_nonce" : dippsy_send_changed_nonce
						}, 
						function(response) 
						{
							var res = jQuery.parseJSON(response);

							if(res.status == "SUCCESS")
							{
								set_yes(status);
							}
							else
							{
								set_no(status);
							}
							
							set_tooltip(status,res.message);
						}
				);
				
			return false;
		});
	
	jQuery('#dippsy_send_completed').live('click', function(e)
			{
				e.preventDefault();
				
				var button = jQuery(this);
				var status = jQuery('.dippsy_completed_status',button.closest('tr'));
				//alert(status);
				
				set_spinner(status);
				
				jQuery.post(ajaxurl, 
						{
							"action":"dippsy_send_completed",
							"dippsy_send_completed_nonce" : dippsy_send_completed_nonce
						}, 
						function(response) 
						{
							var res = jQuery.parseJSON(response);

							if(res.status == "SUCCESS")
							{
								set_yes(status);
							}
							else
							{
								set_no(status);
							}
							
							set_tooltip(status,res.message);
						}
				);
				
			return false;
		});
	
	//file upload
	var dippsy_button_status = jQuery('.dippsy_button_status');
	var dippsy_button_button = jQuery('#dippsy_button_select'), interval;
	
	var image_upload = new AjaxUpload(dippsy_button_button, 
	{
		action: ajaxurl, 
		name: 'dippsy_button',
        autoSubmit: true,
        onSubmit : function(file, ext)
        {
			//get file
			var file = jQuery("input[name=dippsy_button]").val();
	
			if(file.length == 0)
			{
				alert(set_button);
				return false;
			}

			//change button text, when user selects file			
			jQuery("#dippsy_button_select").attr('class', 'uploading');
			
			this.setData({
				"action":'dippsy_add_button',
				"dippsy_add_button_nonce" : dippsy_add_button_nonce,
			});
			
			// If you want to allow uploading only 1 file at time,
			// you can disable upload button
			this.disable();
			
			set_spinner(dippsy_button_status);

		},
		onChange: function(file, ext) 
		{
			jQuery("#dippsy_button_select").attr('class', 'ready');
		},
		onComplete: function(file, response)
		{							
			// enable upload button
			this.enable();
			
			var file = jQuery.parseJSON(response);

			if(file.status == "SUCCESS")
			{
				set_yes(dippsy_button_status);
				jQuery("#dippsy_button_image").attr("src",file.url+"?"+rnd());
			}
			else
			{
				set_no(dippsy_button_status);
			}
			
			set_tooltip(dippsy_button_status,file.message);
			
			jQuery("#dippsy_button_select").attr('class', 'select');
		}
	});
});